%global qtver 4.4
%global kdever 4.3
%global ftglver 2.1.2
%global mikachanver 8.9

Name: kame

%{!?build_nidaqmx: %define build_nidaqmx 1}

Version: 2.9.7
Release: 1
License: GPL
Group: Applications/Engineering
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: qt >= %{qtver}, kdelibs >= %{kdever}
Requires: libart_lgpl, gsl, zlib, ruby, libtool-ltdl, fftw
Requires: libgfortran, atlas-sse2, ftgl >= %{ftglver}
BuildPreReq: ruby-devel, gsl-devel, boost-devel, libtool-ltdl-devel, fftw-devel
BuildPreReq: libgfortran, atlas-sse2-devel
BuildPreReq: libidn-devel, ftgl-devel >= %{ftglver}
BuildPreReq: qt-devel >= %{qtver}, kdelibs >= %{kdever}, kdelibs-devel >= %{kdever}
BuildPreReq: libart_lgpl-devel, zlib-devel, libpng-devel, libjpeg-devel
BuildPreReq: gcc-c++ >= 4.0

Source0: %{name}-%{version}.tar.bz2

Summary: KAME, K's adaptive measurement engine.

%description
K's adaptive measurement engine. 

%package modules-standard
Group: Applications/Engineering
Summary: KAME, K's adaptive measurement engine. Modules.
Requires: kame = %{version}
Requires: linux-gpib
BuildPreReq: linux-gpib-devel
%description modules-standard
K's adaptive measurement engine.
Many standard drivers.

%package modules-nmr
Group: Applications/Engineering
Summary: KAME, K's adaptive measurement engine. Modules.
Requires: kame-modules-standard = %{version}
%description modules-nmr
K's adaptive measurement engine.
NMR drivers.

%if 0%{build_nidaqmx}
%package modules-nidaq
Group: Applications/Engineering
Summary: KAME, K's adaptive measurement engine. Modules.
Requires: kame-modules-nmr = %{version}
Requires: nidaqmxef
BuildPreReq: nidaqmxcapii
%description modules-nidaq
K's adaptive measurement engine.
NMR drivers.
%endif

%prep

%setup -q
export CXX="g++ -g3 -O2 -mfpmath=sse -msse -msse2 -mmmx -march=pentium4 -D__sse2__"
%cmake -DCMAKE_BUILD_TYPE=Debug


%build
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
#if [ -f $RPM_BUILD_ROOT/%{_bindir}/*-kame ]
#then
#	mv $RPM_BUILD_ROOT/%{_bindir}/*-kame $RPM_BUILD_ROOT/%{_bindir}/kame
#fi
%if !0%{build_nidaqmx}
	rm -f $RPM_BUILD_ROOT%{_libdir}/kame/modules/libnidaq*
%endif

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d
cat <<EOF > $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/10-kame.rules
KERNEL=="ttyUSB*", GROUP="uucp", MODE="0666"
KERNEL=="ttyS*", GROUP="uucp", MODE="0666"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_bindir}/kame
%{_datadir}/applications/kde4/*.desktop
%{_datadir}/kde4/apps/kame
%{_datadir}/icons/*/*/apps/*.png
%{_datadir}/locale/*/LC_MESSAGES/*.mo
%{_datadir}/doc/HTML/*/kame
%{_libdir}/kame/modules/libtestdriver*
%{_libdir}/kame/modules/libmontecarlo*

%files modules-standard
%{_sysconfdir}/udev/rules.d/10-kame.rules
%{_libdir}/kame/core_modules/libcharinterface*
%{_libdir}/kame/core_modules/libdcsourcecore*
%{_libdir}/kame/core_modules/libdmmcore*
%{_libdir}/kame/core_modules/libdsocore*
%{_libdir}/kame/core_modules/libmagnetpscore*
%{_libdir}/kame/core_modules/liblevelmetercore*
%{_libdir}/kame/modules/libdcsource*
%{_libdir}/kame/modules/libdmm*
%{_libdir}/kame/modules/libdso*
%{_libdir}/kame/modules/libfuncsynth*
%{_libdir}/kame/modules/liblia*
%{_libdir}/kame/modules/libmagnetps*
%{_libdir}/kame/modules/libtempcontrol*
%{_libdir}/kame/modules/liblevelmeter*
%{_libdir}/kame/modules/libnetworkanalyzer*

%files modules-nmr
%{_libdir}/kame/core_modules/libnmrpulsercore*
%{_libdir}/kame/core_modules/libsgcore*
%{_libdir}/kame/modules/libnmr*
%{_libdir}/kame/modules/libsg*

%if 0%{build_nidaqmx}
%files modules-nidaq
%{_libdir}/kame/modules/libnidaq*
%endif

#the following will be copied from the separated file ChangeLog.
%changelog
* Sun Nov 22 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.7-1)
- Portfile for MacPorts.
- now NI488 can be also used as a GPIB driver.
- x86_64.
- graphpaintergl.cpp: uses QString::toWCharArray instead of the complex iconv().

* Wed Nov 11 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.6-1)
- recordreader.cpp: changes # of threads to 1 for reading records.

* Mon Nov 2 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.5-1)
- Gets rid of XRawThermometer.

* Sat Oct 31 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.4-1)
- Lakeshore340: reading of raw sensor values.

* Thu Oct 29 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.3-1)
- Rearrange UI designs.

* Wed Oct 28 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.1-1)
- No more interval in QTimer's event during processing the main-thread envents.

* Thu Oct 22 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.9.0-1)
- The first working version with Qt4/Kde4.
- cmake.
- Core modules are moved to modules/core.
- Rearranged UIs.

* Fri Oct 16 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.26-1)
- Fix bug in atomic operations.

* Sat Apr 25 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.25-1)
- The first release for Fedora 10.
- dso.cpp, nidaqdso.cpp: Fix for the case where no trace is selected.

* Sat Mar 14 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.24-1)
- nmr: convolute dark PSD by rect window.

* Fri Mar 13 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.23-1)
- nmr: calculate dark side (PSD of noise inferred from background).

* Sat Mar 7 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.22-1)
- nmrspectrumbase: selectable bandwidth.

* Thu Mar 5 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.21-1)
- nmr: clear averaging buffers on starting secondary measurement.
- nmrpulse: check multi-echo settings.
- nmrpulse: solver can be chosen for periodic noise reduction.

* Sat Feb 14 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.20-1)
- pulserdriver.cpp: phase cycle, now 4-cycle available for multiple/stimulated echo sequence.

* Sat Jan 3 2009 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.19-1)
- nmrspectrumbase.cpp: Fix weighting.

* Thu Oct 17 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.18-1)
- dso.cpp: Fix for reading errors.
- lecroy.cpp: Increase timeout.

* Tue Sep 23 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.17-1)
- nmrspectrumbase.cpp: Get rid of noisy parts.
- nmrpulse.cpp: Improve multiecho.

* Fri Sep 12 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.16-1)
- nmrspectrumbase.cpp: Improve autophasing.

* Wed Sep 10 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.15-1)
- nmrfspectrum.cpp: Burst mode.

* Wed Sep 10 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.14-1)
- nmrspectrumbase.cpp: Fix bugs.

* Thu Sep 4 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.13-1)
- freqestleastsquare.cpp: Faster estimation.

* Sun Aug 31 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.12-2)
- math: For IC, detection of number of data points in frequency domain.

* Wed Aug 29 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.12-1)
- nmr, math: Frequency estimater by least square fit with IC.

* Wed Aug 27 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.11-1)
- nmr/spectrumbase: IFT, padding for time domain.
- math/spectrumsolver: rectangular windowing for freq. estimation/MEM.
- sg: No serial poll before writing for HP.

* Thu Jul 10 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.10-1)
- nmr/spectrumbase: Fix for sparse acquision.
- dcsource: No serial poll for YK7651.

* Mon Jul 7 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.9-1)
- nmr/spectrumbase: Fix for sparse acquision.

* Tue Jul 1 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.8-1)
- math: Fix peak detections in spectrum solvers.
- nmr: Impliment digital IF. Catch errors of spectrum solvers.

* Fri Jun 27 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.7-2)
- kame.rules: For udev, ttyUSB*, ttyS*.
- charinterface.cpp: Fox for scanf().

* Sat Jun 21 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.7-1)
- Lecroy/Iwatsu X-Stream DSO.
- tds.cpp: Fix for trigger source.
- gpib.cpp: Fix for partial reading.

* Fri Feb 8 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.6-1)
- Sanwa PC500/5000.

* Fri Jan 25 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.5-1)
- spectrumsolver: Least-Square Phase Estimation.
- spectrumsolver: Combined MEM.

* Mon Jan 21 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.3-1)
- graphpainter: fix for selecting yaxis.
- nmrpulse, nmrspectrumbase, mem: Search for peaks.
- freqest: Freq. estimation. MUSIC.

* Tue Jan 15 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.2-1)
- math : new folder.
- FFTW ver 3.
- nmrspectrum : Abs. plot. Fix for handling weights.

* Fri Jan 11 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.1-2)
- nmrrelax : Convolution w/o FFT.

* Thu Jan 10 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.1-1)
- nmrrelax : Window. Auto-window. Direct Fourier.
- nmrspectrumbase : Its own FFT.

* Thu Jan 3 2008 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.3.0-1)
- nmrpulse, nmrspectrumbase : DSO plots, MEM/AR for DNR & spectra.
- nmrrelax.cpp : Im plot.

* Thu Nov 29 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.20-1)
- nmrpulse : rewrite DNR. Reflect extraAvg while increasing.

* Tue Nov 20 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.19-1)
- Fast read/write 64bit in 32bit machines.
- SSE2 by default.
- Rearrange main form.
- Fix for dead locks.

* Mon Nov 19 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.18-1)
- rubylineshell.
- pulserdrivercore: fix for pregating.

* Fri Nov 16 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.17-1)
- Replace admin dir.
- kame/Makefile.am: simplified.
- configure.in.in: fix for ruby.h.
- node browser.
- node: remember parent.
- nmrcore: merge sgcore and pulsercore.

* Sun Nov 11 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.16-1)
- secondarydriver: Improved stability regarding dead-locks.
- pulserdriver: Improved pre-gating.
- g++-4 for FTGL w/ -fpermissive.
- atomic_prv_x86.h: 64bit support.

* Mon Oct 22 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.15-1)
- network analyzers.
- nmrspectrum, nmrfspectrum: code refactoring & auto scale.

* Sat Oct 20 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.14-1)
- userdmm: HP3478A.

* Mon Sep 10 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.13-1)
- graph: Fix for autoscale faults.

* Sun Jul 29 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.12-2)
- pulserdriver: Arrange for FID.
- nmrrelax: St.E. mode. 2-parameter fitting.

* Fri Jul 27 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.12-1)
- pulserdriver: New option: conserve stimulated echo phase.

* Wed Jul 11 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.11-2)
- xwavengraph: Never use autoscale for weighting axes.

* Thu Jul 5 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.11-1)
- graph: Legends.

* Mon Jul 1 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.10-1)
- xwavengraph: New API for a single y-axis multi-plots.

* Thu Jun 28 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.9-1)
- nmrrelax: increase limit of samples.
- drver: visualize() after aborting.

* Tue Jun 26 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.8-2)
- recordreader: Use multi-thread for time sync again.
- nmrpulse: Much better phase-inversion-cycling.

* Mon Jun 25 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.8-1)
- recordreader: Use single thread for time sync.
- nidaqmx: Create objects w/o NIDAQmx.h somehow.

* Sun Jun 24 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.7-4)
- pulserdriver: Add QSW soft-switching-off functionality.

* Mon Jun 18 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.7-2)
- usertempcontrol: Fix Lakeshore340.
- nmrpulsernidaxmx: Never pause while ASW is active.
- levelmeter: ILM oxford helium level meter. LakeShore LM500 level meter.

* Wed Jun 13 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.7-1)
- usertempcontrol: Neocera LTC21.

* Mon Jun 11 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.6-2)
- rwlock.cpp: Fix for XRecursiveRWLock.

* Thu May 17 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.6-1)
- pulserdrivernidaqmx.cpp: Fix pausing feature for fast sps. Fix possible failure of synchronization.

* Wed May 16 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.5-2)
- nidaqmxdriver.cpp: NI-622x.

* Mon May 14 2007 Kentaro Kitagawa <kitag@issp.u-tokyo.ac.jp>
- (2.2.5-1)
- dcsource: YK7651 supports range.

* Wed Apr 18 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.2.4-1)
- driver.h: Use try lock to avoid deadlocks.

* Tue Apr 14 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.2.3-1)
- nmrpulse.cpp: Handle clear request correctly.
- dcsource: Multi-channel source.
- tempcontrol: Software PID.

* Tue Apr 10 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.2.2-2)
- Disable spinlock.
- Fix montecarlo.

* Mon Apr 2 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.2.2-1)
- Fix for the first software-trigger setup.
- Faster mutex.

* Sun Mar 18 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.2.1-1)
- Fix nidaqmxpulser.
- Get rid of extra new line in xrubysupport.rb.

* Thu Mar 15 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.2-1)
- Dynamic module loading.
- packages: modules-standard (for general drivers with gpib, etc.),
	modules-nmr (NMR drivers), modules-nidaq (NI-DAQmx support).
- Fix SH2 pulser.

* Mon Mar 12 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.5-1)
- Ruby: $SAFE = 3 and begin .. rescue for loading .kame files.
- xnidaqmxpulser.cpp : increase buf size to 2sec.

* Sun Mar 11 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.4-1)
- Fixed TDS.
- Change xsignal.h API.
- Fix scheduler.

* Sat Mar 10 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.3-2)
- Fixed potential crash in nmrpulse.cpp.
- Roll phsase inversion cycle strategy back.

* Fri Mar 9 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.3-1)
- Fixed oxford drivers.
- Fixed phase inversion cycles.

* Tue Mar 7 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.2-4)
- Software trigger.
- Rewritten atomic stuffs.

* Fri Mar 2 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.2-3)
- Support for NI PCI-6115.

* Wed Feb 28 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.2-1)
- NIDAQmx support as NMR pulser and DSO.

* Sat Feb 3 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.0-3)
- introduce XCharDeviceDriver::{open(),close()}, XPrimaryDriver::afterStop()

* Fri Feb 2 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.1.0-2)
- chardevicedriver.h, oxforddriver.h : use such like XCharDeviceDriver<...> for driver w/ one character-based interface.

* Sun Jan 21 2007 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.13-2)
- kame.spec : modified for FedoraCore6.

* Wed Nov 1 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.12-2)
- xrubysupport.{cpp,rb} : Ignore errors on loading .kam.

* Mon Oct 30 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.12-1)
- driver : completely skip after XSkippedRecordError.
- dso, nmrpulse : move averaging rotation to nmrpulse.
- nmrpulse.cpp : Use inversion echoes to cancel background out.

* Wed May 24 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- pulserdriver : Q-Switch support.

* Sun May 14 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.11-1)
- nmrrelaxfit.cpp : more relaxation curves.
- usertempcontrol.cpp : fix crashing.
- support.cpp : new func. formatString().

* Fri May 12 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.10-4)
- Use mutex and deepcopy for i18n(). Use KAME::i18n() to redirect i18n().

* Thu May 11 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.10-3)
- XNIGPIBPort: fix the case for CMPL without END.
- primarydriver.cpp : fix for gcc-4.0

* Tue May 9 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.10-2)
- Switch to Fedra Core 5

* Wed May 3 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.10-1m)
- pulserdriversh.cpp : preliminary induced emission.
- get rid of QString stuff more.

* Tue Mar 7 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.9-1m)
- xnode.cpp, xlistnode.cpp, ... : Use RCU (Read-Copy-Update) to handle children.
- xlistnode.cpp : fix move().

* Sat Mar 5 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.8-1m)
- xlistnode.cpp : move(), change order.
- xnodeconnector.cpp : XListQConnector, dragging.

* Thu Mar 3 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.7-1m)
- bug fix. : Use QDeepCopy<QString> when needed.

* Thu Mar 2 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.6-1m)
- support.cpp : FormatDouble, Use "%.12g" as a default.
- xnode.h : Abondon childLock()/childUnlock().
- caltable.cpp : Display thermometer.

* Wed Mar 1 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.5-1m)
- cspline.cpp : cubic spline approximation.
- thermometer.cpp : new thermometer XApproxThermometer.
- xnodeconnector.cpp : fix display LCD.
- graphform.ui : derived from QMainWidget.
- xrubysupport.cpp : fix unnamed nodes.

* Tue Feb 28 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.4-1m)
- dso.cpp : FIR filter before recording.
- serial.cpp : change init. seq.
- userlockinamp.cpp : SR830 read freq on starting.
- tempcontrol.cpp : make single reading working.

* Sat Feb 11 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.3-2m)
- serial.cpp : revise checking of read count.
- support.cpp : use mutex for debug printings.
- pulserdriversh.cpp : sync with firm 1.2.

* Wed Feb 8 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.3-1m)
- serial.cpp : when read buffer is not empty before writing, throw instead of tcflush().

* Fri Feb 3 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.2-1m)
- dso.cpp, pulserdriver.cpp : change phase cycling sequences
	 and accumulate waves to correct averaging sterategy.

* Thu Feb 2 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0.1-1m)
- atomic_smart_fix.h : fix memory leak using CAS2.

* Wed Feb 1 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- atomic_queue.h : bug fix. uninitialized counter.

* Tue Jan 31 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- pulserdriver{sh,h8}.cpp : try to continue when turning-on is failed.
- atomic_smart_ptr.h : atomic_shared_ptr<>.compareAndSwap()

* Mon Jan 30 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-1.0.2m)
- atomic_smart_ptr.h : atomic_shared_ptr<>, lock-free scanning without CAS2.
- entrylistconnector.cpp : fix handling of transaction.
- analyzer.cpp : bug fix.
- atomic_queue.h : bug fix.

* Sun Jan 29 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-1.0.1m)
- atomic_queue.h : atomic queue, but reserved size is fixed.

* Fri Jan 27 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-1.0.1m)
- atomic.h, xtime.cpp : use assembly on powerPC as well.

* Thu Jan 26 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-1m)
- The first release of 2.0!
- Thanks for testers, Y. Ihara and Takeya.
- (bug) FTGL? : 2byte-chars cause crash.

* Tue Jan 24 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.8m)
- 2.0rc2
- xsignal.cpp : cease to read std::deque without mutex locking.
- atomic.h : atomic<>, memory barrierred wrapper to word-size type.
- todo : use QDeepCopy<QString> properly.

* Sat Jan 21 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- atomic_smart_ptr.h : atomic version of shared_ptr, scoped_ptr.
- fast_smart_ptr.h : faster version of shared_ptr, weak_ptr etc.
- xtime.h : timeStampInUsec(), use RDTSC in x86.
- XTalker<>::empty() : a hint to omit talking.

* Thu Jan 19 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- atomic_prv.h : atomicCompareAndSwap2(), 2 words CAS only for x86.
- atomic.h : implement wait-free atomic_shared_ptr<>. 2 words CAS is needed to make it wait-free.

* Wed Jan 18 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.7m)
- 2.0rc1
- driverlistconnector.cpp : onRecordRedirected() is moved to tcons,
	 because label (a member of tcons) must exist when the function is called. 
- atomic.h : atomic_scoped_ptr<> which supports atomic swap for destructive reading.
- atomic_prv.h : memoryBarrier() etc.
- xsignal.h : apply atomic_scoped_ptr<>, scoped_ptr<>.
	 Now argument is not shared among thransactions.
- graphpaintergl.cpp : Use QGLContext instead of QGLWidget.

* Tue Jan 17 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.6m)
- 2.0beta3
- atomic.h : various atomic operations. atomic_shared_ptr<>.
- xsignal.h : apply atomic_shared_ptr<>
- xnode.h : apply atomic_shared_ptr<>
- thread.h : XScopedLock<>, XScopedReadLock<>, XScopedWriteLock<>.
	better handlings of muteces.
- xnodeconnector.cpp : no need of XThreadLocal<> for containing shared_ptr.

* Fri Jan 13 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.5m)
- 2.0beta2
- xnode.cpp : use typeid() for getTypename()
- XML : xmlsupport is deprecated.
- configure : --with-malloc-debug option is added to use MallocDebug.app in MacOS X.
- kame.cpp : fix terrible memory leak.
- nmrrelaxfit.cpp : do_nlls(), fix memory leak.

* Thu Jan 12 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.4m)
- gpib.cpp : use wait before read, write.
- serial.cpp : time-out is enabled (3s).
- support.cpp : leak detector is enabled when boehm gc and libgccpp are avaliable.
	use class kame_gc as a base to detect leaks.
- xnode.cpp : definitions of XValueNode<> stuff is now in source.

* Mon Jan 9 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.3m)
- xnode.h : setValidator(), validator throws exception when input string is ill to convert
- support.h : formatDoubleValidator(), checks format string

* Sat Jan 7 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.2m)
- nmrfspectrum.cpp : new driver
- support.cpp: formatDouble(), cease to use qt's conversion from double to QString(),
	 because some versions of qt is buggy.

* Fri Jan 6 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9.1m)
- tools : script to make lite package which does not have NMR stuff.
- APIs : const modifiers.
- signalgenerator.cpp : new driver

* Wed Jan 4 2006 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (2.0-0.9m)
- 2.0beta1
- graphpaintergl.cpp : use UCS-4 instead of wchar_t for iconv to avoid locale dependency
- users/lia, users/magnetps, users/tempcontrol, most of users/nmr : ready
- support.cpp : impliment XKameError, base of exception classes
- driver : now GUI can create/release drivers
- interfacelistconnector.cpp : individual RUN/STOP button
- xwavengraph.cpp : change icon after the first dump.
- xnodeconnector.cpp : XFileStream is abadoned.
- i18n : in progress.
- APIs : fixed, i guess.

* Wed Dec 21 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- 2.0alpha2
- graph : Remove XChart
- analyzer, graph : use XDriver::time() as x axis of XValChart
- support.cpp : impliment formatDouble()
- XTextWriter : LastLine node

* Tue Dec 20 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- 2.0alpha1
- API : almost fixed
- all : revised, rewriten
- include FTGL tree for convrnience
- users/dmm, users/dso : ready
- graphwidget.cpp : TODO, event loop is busy while mouse is moving on

* Fri Oct 7 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.9-1m)
- Makefile.am : fix to be configured under the other dirs
- *.ui : fix for qt-3.3.5
- thermometers.{cpp,h} : New thermometer Scientific Instruments

* Wed Oct 5 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-16m)
- lockinamp : support freq. change
- AUTOHEADER may be autoheader-2.53 

* Thu Aug 13 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-14m)
- pulserdriversh.cpp : fix potential deadlock

* Thu Aug 13 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-13m)
- pulserdriversh.cpp : fix for long period (>60sec)
- kame : works with Mac OS X

* Thu Jan 22 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-12m)
- pulserdriver{h8, sh}.cpp : fix gate2 handlings for small tau

* Thu Jan 19 2005 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-11m)
- usertempcontrol.cpp: new driver: Cryo-con M32

* Thu Dec 13 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-10m)
- itcp.cpp: improve scheduling
- graph.cpp: avoid loop of redrawRequest

* Thu Dec 11 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-9m)
- itcp.cpp: Scheduling changed. Lock until old queue (>90 ms before)  gets cleared

* Thu Dec 11 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-8m)
- graph: bug fixes

* Thu Dec 10 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-7m)
- graph: reduce memory usage

* Thu Dec 10 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-6m)
- magnetps.cpp: PS w/o PCS supported
- graphpainter.cpp: quick help

* Thu Dec 10 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-5m)
- Kick out buggy QGLWidget::renderText. Apply FTGLPixmapFont instead.
- Mikachanfont which has no embeded fixed scale fonts is prefered.

* Thu Dec 6 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-4m)
- Gzip format is applied for raw stream binary

* Thu Dec 4 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-3m)
- support selection in 3D plot

* Thu Dec 1 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-2m)
- 3D plot functionality

* Thu Nov 29 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8.2-1m)
- 1.8.2
- support for OpenGL graphs, but still only for 2D plots

* Thu Nov 25 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8-2m)
- revise spec

* Thu Nov 25 2004 Kentaro Kitagawa <kitagawa@scphys.kyoto-u.ac.jp>
- (1.8-1m)
- The first release.